#INCLUDE "Topconn.ch"
#INCLUDE "Protheus.ch"

/*


ͻ
Programa  ROS002   Autor  Cludio Duarte   Data  29/01/2016 		
͹
Desc. Impresso de relatrio de ordem de servios em TReport simples. 
                                                                      
͹
Uso        ErpSafe		                                               
ͼ


*/
User Function ROS002() 

//Ŀ
//Declaracao de variaveis                   
//

Private oReport  := Nil
Private oSecCab	 := Nil
Private cPerg 	 := PadR ("ROS002", Len (SX1->X1_GRUPO))  

//Ŀ
//Criacao e apresentacao das perguntas      
// 


PutSx1(cPerg,"01","Cdigo do consultor?"  ,'','',"mv_ch1","C",TamSx3 ("Z9_CODCONS")[1] ,0,,"G","","SZ9","","S","mv_par01","","","","","","","","","","","","","","","","")
PutSx1(cPerg,"02","Data inicial?"         ,'','',"mv_ch2","D",8,0,0,"G","","","","S","mv_par02","","","","","","","","","","","","","","","","")
PutSx1(cPerg,"03","Data final?"           ,'','',"mv_ch3","D",8,0,0,"G","","","","S","mv_par03","","","","","","","","","","","","","","","","")

//Ŀ
//Definicoes/preparacao para impressao      
// 

ReportDef()    //Nesta funo nos definimos a estrutura do relatrio, por exemplo as sees, campos, totalizadores e etc.
oReport	:PrintDialog()	//PRINTDIALOG- Essa funo serve para disparar a impresso do TReport,  ela que faz com que seja 
								//exibida a tela de configurao de impressora e os botes de parmetros.

Return Nil
/*


ͻ
Programa  ReportDef Autor   Cludio Duarte    Data  29/01/2016	  
͹
Desc.      Definio da estrutura do relatrio.                       
                                                                      
͹
Uso                                                                   
ͼ


*/
Static Function ReportDef()

oReport := TReport():New("ROS002","Ordens de servio",cPerg,{|oReport| PrintReport(oReport)},"Impresso de relao de ordens de servio.")
oReport:SetLandscape(.T.)
/*
oReport-serve para controle do relatrio, carregamos tambm a varivel.
oSecCab-serve para controle da seo.
TRCell - serve para adicionar novos campos na seo.
*/
oSecCab := TRSection():New( oReport , "Ordens de servio", {"QRY"} )
TRCell():New( oSecCab, "Z9_DATA"     	, "QRY")
TRCell():New( oSecCab, "Z9_CLIENTE"    , "QRY")
TRCell():New( oSecCab, "Z9_HORAINI"    , "QRY")
TRCell():New( oSecCab, "Z9_HORAFIM"    , "QRY")
TRCell():New( oSecCab, "Z9_HORATRA"    , "QRY")
TRCell():New( oSecCab, "Z9_HORAALM"    , "QRY")
TRCell():New( oSecCab, "Z9_HORATOT"    , "QRY")   

//TRFunction -  um totalizador

//TRFunction():New(/*Cell*/             ,/*cId*/,/*Function*/,/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,/*lEndSection*/,/*lEndReport*/,/*lEndPage*/,/*Section*/)
TRFunction():New(oSecCab:Cell("Z9_HORATOT"),/*cId*/,"COUNT"     ,/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,.F.           ,.T.           ,.F.        ,oSecCab)

Return Nil
/*


ͻ
Programa  ROS002   Autor   Cludio Duarte    Data  29/01/2016	  
͹
Desc.           	  BUSCA DOS REGISTROS QUE DEVERO SER IMPRESSOS   
                                                                      
͹
Uso                                                                   
ͼ


*/
Static Function PrintReport(oReport)

Local cQuery     := ""

Pergunte(cPerg,.F.)

cQuery += " SELECT " + CRLF
	cQuery += " SZ9.Z9_DATA, " + CRLF
	cQuery += " SZ9.Z9_CLIENTE, " + CRLF
	cQuery += " SZ9.Z9_HORAINI, " + CRLF
	cQuery += " SZ9.Z9_HORAFIM, " + CRLF
	cQuery += " SZ9.Z9_HORATRA, " + CRLF
	cQuery += " SZ9.Z9_HORAALM, " + CRLF
	cQuery += " SZ9.Z9_HORATOT  " + CRLF
	cQuery += " FROM " + RetSqlName("SZ9") + " SZ9 " + CRLF
	cQuery += " WHERE SZ9.Z9_FILIAL = '" + xFilial ("SZ9") + "' " + CRLF
	cQuery += " AND SZ9.Z9_CODCONS = '" + mv_par01 + "' " + CRLF
	cQuery += " AND SZ9.Z9_DATA BETWEEN '" + Dtos(mv_par02) + "' AND '" + Dtos(mv_par03) + "' " + CRLF
	cQuery += " AND SZ9.D_E_L_E_T_ = ' ' " + CRLF
cQuery := ChangeQuery(cQuery)

If Select("QRY") > 0  // SELECT TRAZ A AREA DE TRABALHO EM VALOR NUMRICO, SE NO EXISTE TRAZ ZERO. 
					// Nesse caso, se ele existir , logo ser qualquer nmero de 0 a 250 e portando deve se fechar ele.
	Dbselectarea("QRY")
	QRY->(DbClosearea())  // s funciona no alias ativo na conexo, logo  necessrio estar junto do dbselectarea 
						 //que faz a abertura.
	
EndIf

TcQuery cQuery New Alias "QRY"

oSecCab:BeginQuery()
oSecCab:EndQuery({{"QRY"},cQuery})    
oSecCab:Print()

Return


